<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procart Enterprise 3.8                                       ***
  ***      File:  admin_forum_settings.php                                 ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("forum");

	$message_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);

	$validation_types = 
		array( 
			array(2, "All Users"), array(1, "Unregistered User Only"), array(0, "Not Used")
		);

	$show_topic_information = 
		array( 
			array(1, "Always at the top"), array(0, "Never")
		);

	$show_reply_form = 
		array( 
			array(1, "Above the messages list"), array(2, "Below the messages list")
		);

	$messages_order = 
		array( 
			array(1, "Ascending"), array(2, "Descending")
		);

	$show_user_info = 
		array( 
			array(1, "Show user info with image on the left"), array(2, "Show user info (no image) on the top")
		);

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_forum_settings.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_forum_settings_href", "admin_forum_settings.php");
	$t->set_var("admin_forum_help_href", "admin_forum_help.php");
	$t->set_var("admin_email_help_href", "admin_email_help.php");

	$r = new VA_Record($table_prefix . "global_settings");

	// set up html form parameters

	$r->add_radio("use_random_image", TEXT, $validation_types);
	$r->add_radio("topic_information", TEXT, $show_topic_information);
	$r->add_radio("reply_form", TEXT, $show_reply_form);
	$r->add_radio("sort_messages", TEXT, $messages_order);
	$r->add_radio("user_info", TEXT, $show_user_info);
	$r->add_textbox("user_no_image", TEXT);
	$r->add_checkbox("admin_notification", INTEGER);
	$r->add_textbox("admin_email", TEXT);
	$r->add_textbox("admin_mail_from", TEXT);
	$r->add_textbox("cc_emails", TEXT);
	$r->add_textbox("admin_mail_bcc", TEXT);
	$r->add_textbox("admin_mail_reply_to", TEXT);
	$r->add_textbox("admin_mail_return_path", TEXT);
	$r->add_textbox("admin_subject", TEXT);
	$r->add_radio("admin_message_type", TEXT, $message_types);
	$r->add_textbox("admin_message", TEXT);

	$r->add_checkbox("user_notification", INTEGER);
	$r->add_textbox("user_mail_from", TEXT);
	$r->add_textbox("user_mail_cc", TEXT);
	$r->add_textbox("user_mail_bcc", TEXT);
	$r->add_textbox("user_mail_reply_to", TEXT);
	$r->add_textbox("user_mail_return_path", TEXT);
	$r->add_textbox("user_subject", TEXT);
	$r->add_radio("user_message_type", TEXT, $message_types);
	$r->add_textbox("user_message", TEXT);
                                                   
	$r->get_form_values();

	$operation = get_param("operation");
	$return_page = get_param("rp");
	if(!strlen($return_page)) $return_page = "admin.php";
	$errors = "";

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}

		if (!function_exists('imagecreate') && (($r->get_value("use_random_image") == 2) || ($r->get_value("use_random_image") == 1 ))) {	
		  $errors .= "Sorry, to use Random Image Validation please install <a href='http://www.php.net/gd' target='_blank'> php graphical library gd</a>.";
			$r->set_value("use_random_image",0);
		} 

		if(!strlen($errors))
		{
			$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='forum'";
			$db->query($sql);
			foreach($r->parameters as $key => $value)
			{
				$sql  = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES (";
				$sql .= "'forum', '" . $key . "'," . $db->tosql($value[CONTROL_VALUE], TEXT) . ")";
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
	}
	else // get order_info settings
	{
		foreach($r->parameters as $key => $value)
		{
			$sql  = "SELECT setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= "WHERE setting_type='forum' AND setting_name='" . $key . "'";
			$r->set_value($key, get_db_value($sql));
		}
	}

	$r->set_parameters();
	$t->set_var("rp", htmlspecialchars($return_page));

	if(strlen($errors))
	{
		$t->set_var("errors_list", $errors);
		$t->parse("errors", false);
	}
	else
	{
		$t->set_var("errors", "");
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>