<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procart Enterprise 3.8                                       ***
  ***      File:  admin_support_request.php                                ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");

	check_admin_security("support");

	$eol = get_eol();

 	$t = new VA_Template($settings["admin_templates_dir"]);
 	$t->set_file("main","admin_support_request.html");
	$t->set_var("admin_support_request_href", "admin_support_request.php");

	$admin_support_url = new VA_URL("admin_support.php", false);
	$admin_support_url->add_parameter("s_w", REQUEST, "s_w");
	$admin_support_url->add_parameter("s_s", REQUEST, "s_s");
	$admin_support_url->add_parameter("sort_ord", REQUEST, "sort_ord");
	$admin_support_url->add_parameter("sort_dir", REQUEST, "sort_dir");
	$return_page = $admin_support_url->get_url();
	$t->set_var("admin_support_url", $return_page);
	$t->set_var("site_url", $settings["site_url"]);

	$permissions = get_permissions();
	$allow_close = get_setting_value($permissions, "support_ticket_close", 0); 
	$operation = get_param("operation");
	$support_id = get_param("support_id");
	$send_mail = get_param("send_mail");
	$rp = get_param("rp");
	$return_page = (strlen($rp) && $operation != "delete") ? $rp : $return_page;

	$r = new VA_Record($table_prefix . "support");
	$r->return_page = $return_page;

	$r->add_where("support_id", INTEGER);

	$r->add_hidden("s_w", TEXT);
	$r->add_hidden("s_s", TEXT);
	$r->add_hidden("sort_ord", TEXT);
	$r->add_hidden("sort_dir", TEXT);

	$r->add_textbox("user_id", INTEGER, "Customer ID");
	$r->add_textbox("user_name", TEXT, "Customer Name");
	$r->parameters["user_name"][REQUIRED] = true;
	$r->add_textbox("user_email", TEXT, "Customer Email");
	$r->parameters["user_email"][REQUIRED] = true;
	$r->add_textbox("identifier", TEXT);
	$r->add_textbox("environment", TEXT);
	$r->add_textbox("remote_address", TEXT);

	//Departments and assigned users
	$deps_users = "";
	$sql = "SELECT sud.dep_id, sud.admin_id, a.admin_name FROM " . $table_prefix . "support_users_departments sud, ";
	$sql .= $table_prefix . "admins a WHERE sud.admin_id = a.admin_id ORDER BY a.admin_name";
	$db->query($sql);
	if ($db->next_record()) {
		$i = 0;
		do {
			$deps_users .= "arrDepsUsers[" . $i . "] = Array(" . $db->f("dep_id") . ", " . $db->f("admin_id") . ", " . $db->tosql($db->f("admin_name"), TEXT) . ");" . $eol;
			$i++;
		} while ($db->next_record());
	}
	$t->set_var("deps_users", $deps_users);

	$number_of_products = get_db_value("SELECT COUNT(*) FROM " . $table_prefix . "support_products");
	$support_products = get_db_values("SELECT product_id, product_name FROM " . $table_prefix . "support_products", array(array("", "Select Product")));
	$r->add_select("support_product_id", INTEGER, $support_products, "Product");
	$r->parameters["support_product_id"][REQUIRED] = true;
	if($number_of_products < 2) {
		$r->parameters["support_product_id"][SHOW] = false;
		$only_product_id = get_db_value("SELECT product_id FROM " . $table_prefix . "support_products");
	}

	$admins = get_db_values("SELECT admin_id, admin_name FROM " . $table_prefix . "admins ", array(array("", "Select Responsible")));
	$r->add_select("admin_id_assign_to", INTEGER, $admins);
	
	$number_of_deps = get_db_value("SELECT COUNT(*) FROM " . $table_prefix . "support_departments");
	$support_deps = get_db_values("SELECT dep_id, short_title FROM " . $table_prefix . "support_departments", array(array("", "Select Department")));
	$r->add_select("dep_id", INTEGER, $support_deps, "Department");
	$r->parameters["dep_id"][REQUIRED] = true;
	if($number_of_deps < 2) {
		$only_dep_id = get_db_value("SELECT dep_id FROM " . $table_prefix . "support_departments");
	}

	$support_types = get_db_values("SELECT type_id, type_name FROM " . $table_prefix . "support_types", array(array("", "Select Type")));
	$r->add_select("support_type_id", INTEGER, $support_types, "Type");
	$r->parameters["support_type_id"][REQUIRED] = true;

	$sql = " SELECT status_id, status_name, is_internal FROM " . $table_prefix . "support_statuses ";
	if (!$allow_close) {
		$sql .= " WHERE (is_closed IS NULL OR is_closed<>1)";
	}
	$sql .= " ORDER BY status_name ASC ";
	$support_statuses = array(array("", "Select Status"));
	$db->query($sql);
	while($db->next_record()) {
		if ($db->f("is_internal") == "1") {
			$support_statuses[] = array($db->f("status_id"), $db->f("status_name") . " (Internal)");
		}
		else {
			$support_statuses[] = array($db->f("status_id"), $db->f("status_name"));
		}
	};
	$r->add_select("support_status_id", INTEGER, $support_statuses, "Status");
	$r->parameters["support_status_id"][REQUIRED] = true;

	$support_priorities = get_db_values("SELECT priority_id, priority_name FROM " . $table_prefix . "support_priorities", array(array("", "Select Priority")));
	$default_priority = get_db_value("SELECT priority_id FROM " . $table_prefix . "support_priorities WHERE is_default=1 ");
	$r->add_select("support_priority_id", INTEGER, $support_priorities, "Priority");
	$r->parameters["support_priority_id"][REQUIRED] = true;

	$r->add_textbox("summary", TEXT, "Summary");
	$r->parameters["summary"][REQUIRED] = true;
	$r->add_textbox("description", TEXT, "Description");
	$r->parameters["description"][REQUIRED] = true;

	// editing information
	$r->add_textbox("admin_id_added_by", INTEGER);
	$r->change_property("admin_id_added_by", USE_IN_UPDATE, false);
	$r->add_textbox("admin_id_modified_by", INTEGER);
	$r->change_property("admin_id_modified_by", USE_IN_INSERT, false);
	$r->add_textbox("date_added", DATETIME);
	$r->change_property("date_added", USE_IN_UPDATE, false);
	$r->add_textbox("date_modified", DATETIME);

	$r->get_form_values();
	
	$t->set_var("cur_admin_id", intval($r->get_value("admin_id_assign_to")));

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $support_id)
		{
			if (isset($permissions["support_ticket_edit"]) && $permissions["support_ticket_edit"] == 1) {

				// delete attachments if available
				$sql = "SELECT file_path FROM " . $table_prefix . "support_attachments WHERE support_id=" . $db->tosql($support_id, INTEGER);
				$db->query($sql);
				while ($db->next_record()) {
					$file_path = $db->f("file_path");
					@unlink($file_path);
				}
				
				$db->query("DELETE FROM " . $table_prefix . "support_attachments WHERE support_id=" . $db->tosql($support_id, INTEGER));
				$db->query("DELETE FROM " . $table_prefix . "support_messages WHERE support_id=" . $db->tosql($support_id, INTEGER));
				$db->query("DELETE FROM " . $table_prefix . "support WHERE support_id=" . $db->tosql($support_id, INTEGER));

				header("Location: " . $return_page);
				exit;
			} else {
				$r->errors = "Sorry, but you are not allowed to remove tickets.<br>";
			}
		}

		if ($number_of_products == 1) {
			$r->set_value("support_product_id", $only_product_id);
		} else if ($number_of_products < 1) {
			$r->set_value("support_product_id", 0);
		}
		
		$is_valid = $r->validate();

		if($is_valid)
		{
			$r->set_value("admin_id_added_by", get_session("session_admin_id"));
			$r->set_value("admin_id_modified_by", get_session("session_admin_id"));
			$r->set_value("date_added", va_time());
			$r->set_value("date_modified", va_time());
			
			if ($r->is_empty("user_id")) { 
				$r->set_value("user_id", 0);
			}
			if ($r->is_empty("admin_id_assign_to")) { 
				$r->set_value("admin_id_assign_to", 0);
			}
			
			$record_updated = false;
			if(strlen($r->get_value("support_id"))) {
				if (isset($permissions["support_ticket_edit"]) && $permissions["support_ticket_edit"] == 1) {
					$record_updated = $r->update_record();
				} else {
					$r->errors = "Sorry, but you are not allowed to update tickets.<br>";
				}
			} else {
				if (isset($permissions["support_ticket_new"]) && $permissions["support_ticket_new"] == 1) {
					$record_updated = $r->insert_record();
					if ($record_updated)
					{
						$support_settings = array();
						$sql = "SELECT setting_name, setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='support'";
						$db->query($sql);
						while($db->next_record()) {
							$support_settings[$db->f("setting_name")] = $db->f("setting_value");
						}
						$outgoing_account = get_db_value("SELECT outgoing_account FROM " . $table_prefix . "support_departments WHERE dep_id = " . $db->tosql($r->get_value("dep_id"), INTEGER));

						$sql = "SELECT MAX(support_id) FROM " . $table_prefix . "support";
						$support_id = get_db_value($sql);
						
						$sql  = " SELECT s.support_id , s.user_id, s.user_name, s.remote_address, s.identifier, ";
						$sql .= " s.environment, p.product_name, st.type_name, s.summary, s.description, ";
						$sql .= " ss.status_name, ss.status_id, sp.priority_name, s.date_added, s.date_modified, ";
						$sql .= " aa.admin_name as assign_to, s.date_viewed ";
						$sql .= " FROM (((((" . $table_prefix . "support s ";
						$sql .= " LEFT JOIN " . $table_prefix . "support_products p ON p.product_id=s.support_product_id) ";
						$sql .= " LEFT JOIN " . $table_prefix . "support_statuses ss ON ss.status_id=s.support_status_id) ";
						$sql .= " LEFT JOIN " . $table_prefix . "support_types st ON st.type_id=s.support_type_id) ";
						$sql .= " LEFT JOIN " . $table_prefix . "support_priorities sp ON sp.priority_id=s.support_priority_id) ";
						$sql .= " LEFT JOIN " . $table_prefix . "admins aa ON aa.admin_id=s.admin_id_assign_to) ";
						$sql .= " WHERE s.support_id=" . $db->tosql($support_id, INTEGER);
						$db->query($sql);
						if($db->next_record())
						{
							$support_id = $db->f("support_id");
							$t->set_var("support_id", $support_id);
							$t->set_var("user_id", $db->f("user_id"));
							$t->set_var("user_name", $db->f("user_name"));
							$t->set_var("identifier", htmlspecialchars($db->f("identifier")));
							$t->set_var("environment", htmlspecialchars($db->f("environment")));
							$t->set_var("remote_address", $db->f("remote_address"));
							$t->set_var("product", $db->f("product_name"));					
							$t->set_var("assign_to", $db->f("assign_to"));
							$t->set_var("type", $db->f("type_name"));
							$current_status = strlen($db->f("status_name")) ? $db->f("status_name") : "New";
							$t->set_var("current_status", $current_status);
							$priority = strlen($db->f("priority_name")) ? $db->f("priority_name") : "Normal";
							$t->set_var("priority", $priority);
							
							$date_added = $db->f("date_added", DATETIME);
							$request_added_string = va_date($datetime_show_format, $date_added);
							$t->set_var("request_added", $request_added_string);
							$t->set_var("message_added", $request_added_string);
										
							$date_modified = $db->f("date_modified", DATETIME);
							$date_modified_string = va_date($datetime_show_format, $date_modified);
							$t->set_var("date_modified", $date_modified_string);
					
							$summary = $db->f("summary");
							$t->set_var("summary", htmlspecialchars($summary));
							$description = $db->f("description");
							$t->set_var("description", $description);
							$t->set_var("message_text",$description);
							
							$vc = md5($support_id . $date_added[3].$date_added[4].$date_added[5]);
							$support_url = $settings["site_url"] . "support_messages.php?support_id=" . $support_id . "&vc=" . $vc;
							$t->set_var("vc", $vc);
							$t->set_var("support_url", $support_url);						
						}
						
						// send email notification to admin
						if ($support_settings["admin_notification"] && $r->get_value("admin_id_assign_to")) 
						{
							$t->set_block("admin_subject", $support_settings["admin_subject"]);
							$t->set_block("admin_message", $support_settings["admin_message"]);

							$admin_email = get_db_value("SELECT email FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql($r->get_value("admin_id_assign_to"), INTEGER));
		
							if(strlen($outgoing_account)) {
								$mail_from = $outgoing_account;
							} else {
								$mail_from = get_setting_value($support_settings, "admin_mail_from", $settings["admin_email"]);
							}
							$mail_cc = get_setting_value($support_settings, "cc_emails");
							$mail_bcc = get_setting_value($support_settings, "admin_mail_bcc");
							$mail_reply_to = get_setting_value($support_settings, "admin_mail_reply_to");
							$mail_return_path = get_setting_value($support_settings, "admin_mail_return_path");
							$mail_type = get_setting_value($support_settings, "admin_message_type");
							$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

							$t->parse("admin_subject", false);
							$t->parse("admin_message", false);

							$admin_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("admin_message"));
							@mail($admin_email, $t->get_var("admin_subject"), $admin_message, $email_headers);
						}
		
						// send email notification to user
						if ($send_mail)
						{
							$t->set_block("user_subject", $support_settings["user_subject"]);
							$t->set_block("user_message", $support_settings["user_message"]);

							if(strlen($outgoing_account)) {
								$mail_from = $outgoing_account;
							} else {
								$mail_from = get_setting_value($support_settings, "user_mail_from", $settings["admin_email"]);
							}
							$mail_cc = get_setting_value($support_settings, "user_mail_cc");
							$mail_bcc = get_setting_value($support_settings, "user_mail_bcc");
							$mail_reply_to = get_setting_value($support_settings, "user_mail_reply_to");
							$mail_return_path = get_setting_value($support_settings, "user_mail_return_path");
							$mail_type = get_setting_value($support_settings, "user_message_type");
							$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);
							$email_headers = "To: " . $r->get_value("user_name") . " <" . $r->get_value("user_email") . ">" . $eol . $email_headers;

							$t->parse("user_subject", false);
							$t->parse("user_message", false);

							$user_message = preg_replace("/\r\n|\r|\n/", $eol, $t->get_var("user_message"));
							@mail($user_email, $t->get_var("user_subject"), $user_message, $email_headers);
						}
					}
				} else {
					$r->errors = "Sorry, but you are not allowed to create new tickets.<br>";
				}
			}

			if ($record_updated) {
				header("Location: " . $return_page);
				exit;
			}
		}
	} else if (strlen($r->get_value("support_id"))) {
		$r->get_db_values();
		$t->set_var("cur_admin_id", intval($r->get_value("admin_id_assign_to")));
		if ($r->get_value("user_id") == 0) { 
			$r->set_value("user_id", "");
		}
		$t->set_var("send_mail", "");
	}
	else // new item (set default values)
	{
		if (isset($only_dep_id) && strlen($only_dep_id)) {
			$r->set_value("dep_id", $only_dep_id);
		}
		$r->set_value("support_priority_id", $default_priority);
		$t->parse("send_mail", false);
	}

	$r->set_parameters();
	
	if(strlen($support_id))	
	{
		if (isset($permissions["support_ticket_edit"]) && $permissions["support_ticket_edit"] == 1) {
			$t->parse("update_button", false);
			$t->parse("delete", false);	
		}
	}
	else
	{
		if (isset($permissions["support_ticket_new"]) && $permissions["support_ticket_new"] == 1) {
			$t->parse("add_button", false);
		}
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_support_href", "admin_support.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("rp", htmlspecialchars($return_page));

	$t->pparse("main");

?>