<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procart Enterprise 3.8                                       ***
  ***      File:  admin_tax_rates.php                                      ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");

	check_admin_security("sales_orders");
	check_admin_security("tax_rates");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_tax_rates.html");

	$t->set_var("admin_tax_rates_href", "admin_tax_rates.php");
	$t->set_var("admin_tax_rate_href", "admin_tax_rate.php");

	$s = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_tax_rates.php");
	$s->set_sorter("ID", "sorter_tax_id", "1", "tax_id");
	$s->set_sorter("Country", "sorter_country_name", "2", "country_name");
	$s->set_sorter("State", "sorter_state_name", "3", "state_name");
	$s->set_sorter("Tax Percent", "sorter_tax_percent", "4", "tax_percent");
	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_tax_rates.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	// set up variables for navigator
	$db->query("SELECT COUNT(*) FROM " . $table_prefix . "tax_rates");
	$db->next_record();
	$total_records = $db->f(0);
	$records_per_page = get_param("q") > 0 ? get_param("q") : 25;
	$pages_number = 5;
	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);

	$sql  = " SELECT tr.tax_id,c.country_name,s.state_name,tr.tax_percent ";
	$sql .= " FROM ((" . $table_prefix . "tax_rates tr ";
	$sql .= " INNER JOIN " . $table_prefix . "countries c ON c.country_code=tr.country_code) ";
	$sql .= " LEFT JOIN " . $table_prefix . "states s ON s.state_code=tr.state_code) ";
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query($sql . $s->order_by);
	if($db->next_record())
	{
		$t->set_var("no_records", "");
		do {
			$t->set_var("tax_id", $db->f("tax_id"));
			$t->set_var("country_name", $db->f("country_name"));
			$t->set_var("state_name", $db->f("state_name"));
			$t->set_var("tax_percent", number_format($db->f("tax_percent"), 3));
			$t->parse("records", true);
		} while($db->next_record());
	}
	else
	{
		$t->set_var("records", "");
		$t->set_var("navigator", "");
		$t->parse("no_records", false);
	}

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_lookup_tables_href", "admin_lookup_tables.php");
	$t->pparse("main");

?>
